/*
  Melody_bolgar

  Plays Bolgariam Waltz from Apple II (Bolgarian an Russian clones)
  
  circuit:
  
  Piezo-speaker on digital pin 8

  created 24 Jun 2020
  
  by Dmitriy Korabelnikov aka Deckard of Atomic Destruction
  e-mail:
  d_korabelnikov@mail.ru
  site:
  http://atd-group.narod.ru
*/  

#include "bolgar.h"

//Place your beeper pin number here
const int buzzer = 8;
unsigned int freq; 

void toneWithDelay (uint8_t _pin, unsigned int frequency, unsigned long duration)
{
  unsigned long TimeMs, TimeUs;
  unsigned int Micros;
  char PinValue;
  
  PinValue = 0;
  TimeMs = millis();
  Micros = 500000L / frequency;
  while (!((millis() - TimeMs) >= duration)) {
    TimeUs = micros();
    while (!((micros() - TimeUs) >= Micros));
    PinValue = ~PinValue;
    if (frequency) digitalWrite(_pin, PinValue);
  }
  digitalWrite(_pin, 0);
} 

unsigned int durat(unsigned int i)
{if (i<132) return 50;else return pgm_read_byte(fixdurat+(i-132));}

void play(const unsigned char *melody)
{unsigned char d;unsigned int i;
 for (i=0;d=pgm_read_byte(melody+i), d != 255;i++) {if (d != 1) freq=30000/d;else freq=0;toneWithDelay(buzzer,freq,durat(i)*3);}
} 

 void setup()
{
 pinMode(buzzer,OUTPUT);play(notes);
}

void loop()
{}


