/*
  Melody_danube

  Plays Blue Danube Waltz from IBM PC XT BASIC Music.BAS (1982)

  circuit:
  
  Piezo-speaker on digital pin 8

  created 25 Jun 2020
  
  by Dmitriy Korabelnikov aka Deckard of Atomic Destruction
  e-mail:
  d_korabelnikov@mail.ru
  site:
  http://atd-group.narod.ru
*/  

#include "freq.h"
#include "danube.h"
//Place your beeper pin number here
const int buzzer = 8;

void toneWithDelay (uint8_t _pin, unsigned int frequency, unsigned long duration)
{
  unsigned long TimeMs, TimeUs;
  unsigned int Micros;
  char PinValue;
  
  PinValue = 0;
  TimeMs = millis();
  Micros = 500000L / frequency;
  while (!((millis() - TimeMs) >= duration)) {
    TimeUs = micros();
    while (!((micros() - TimeUs) >= Micros));
    PinValue = ~PinValue;
    if (frequency) digitalWrite(_pin, PinValue);
  }
  digitalWrite(_pin, 0);
} 

void play(unsigned char *melody)
{unsigned char d,tc;unsigned int f,i;
for (i=0;d=pgm_read_byte(melody+i),tc=pgm_read_byte(melody+i+1), d != 255;i=i+2)
    {if (d != 0) f=pgm_read_word(freq+d-24);else f=0;
toneWithDelay(buzzer,f,60*tc);}
}

void setup()
{
 pinMode(buzzer,OUTPUT);play(notes);
}

void loop()
{}


